diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/lte/model/lte-rrc-header.cc ns-3.36/src/lte/model/lte-rrc-header.cc
--- ns-3.35/src/lte/model/lte-rrc-header.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/lte/model/lte-rrc-header.cc	2022-04-30 18:23:58.046734300 -0700
@@ -651,23 +651,23 @@
     }
 
     std::bitset<4> measResultOptional;
-    measResultOptional.set (3,  measResults.haveScellsMeas);
+    measResultOptional.set (3,  measResults.haveMeasResultServFreqList);
     measResultOptional.set (2, false); //LocationInfo-r10
     measResultOptional.set (1, false); // MeasResultForECID-r9
     measResultOptional.set (0, measResults.haveMeasResultNeighCells);
-    SerializeSequence(measResultOptional,true);
+    SerializeSequence (measResultOptional, true);
 
   // Serialize measId
   SerializeInteger (measResults.measId,1,MAX_MEAS_ID);
 
-  // Serialize measResultServCell sequence
-  SerializeSequence (std::bitset<0> (0),false);
+  // Serialize measResultPCell sequence
+  SerializeSequence (std::bitset<0> (0), false);
 
   // Serialize rsrpResult
-  SerializeInteger (measResults.rsrpResult,0,97);
+  SerializeInteger (measResults.measResultPCell.rsrpResult,0,97);
 
   // Serialize rsrqResult
-  SerializeInteger (measResults.rsrqResult,0,34);
+  SerializeInteger (measResults.measResultPCell.rsrqResult,0,34);
 
   if (measResults.haveMeasResultNeighCells)
     {
@@ -728,40 +728,48 @@
             }
         }
     }
-    if (measResults.haveScellsMeas)
-      {
-        // Serialize measResultNeighCells
-        SerializeSequenceOf (measResults.measScellResultList.measResultScell.size (),MAX_SCELL_REPORT,1);
-        // serialize MeasResultServFreqList-r10 elements in the list
-        std::list<LteRrcSap::MeasResultScell>::iterator it;
-        for (it = measResults.measScellResultList.measResultScell.begin (); it != measResults.measScellResultList.measResultScell.end (); it++)
-          {
-            // Serialize measId
-            SerializeInteger (it->servFreqId,0,MAX_MEAS_ID); // ToDo: change with FreqId, currently is the componentCarrierId
-             // Serialize MeasResultServFreqList
-            std::bitset<2> measResultScellPresent;
-            measResultScellPresent[0] = measResults.measScellResultList.haveMeasurementResultsServingSCells;
-            measResultScellPresent[1] = measResults.measScellResultList.haveMeasurementResultsNeighCell; // Not implemented
-            SerializeSequence (measResultScellPresent,true);
-
-            // Serialize measResult
-            std::bitset<2> measResultScellFieldsPresent;
-            measResultScellFieldsPresent[1] = it->haveRsrpResult;
-            measResultScellFieldsPresent[0] = it->haveRsrqResult;
-            SerializeSequence (measResultScellFieldsPresent,true);
 
-            if (it->haveRsrpResult)
-              {
-                SerializeInteger (it->rsrpResult,0,97);
-              }
+  // measResultServFreqList-r10 serialization
+  if (measResults.haveMeasResultServFreqList)
+    {
+      // Serialize measResultServFreqList-r10
+      SerializeSequenceOf (measResults.measResultServFreqList.size (), MAX_SCELL_REPORT, 1);
+      // serialize MeasResultServFreqList-r10 elements in the list
+      for (const auto &it: measResults.measResultServFreqList)
+        {
+          // Serialize MeasResultServFreq-r10
+          std::bitset<2> measResultServFreqPresent;
+          measResultServFreqPresent[0] = it.haveMeasResultSCell;
+          measResultServFreqPresent[1] = it.haveMeasResultBestNeighCell;
+          SerializeSequence (measResultServFreqPresent, true);
 
-            if (it->haveRsrqResult)
-              {
-                SerializeInteger (it->rsrqResult,0,34);
-              }
-            
-          }
-      }
+          // Serialize servFreqId-r10
+          SerializeInteger (it.servFreqId, 0, 7);
+
+          if (it.haveMeasResultSCell)
+            {
+              // Serialize rsrpResultSCell-r10
+              SerializeInteger (it.measResultSCell.rsrpResult, 0, 97);
+
+              // Serialize rsrqResultSCell-r10
+              SerializeInteger (it.measResultSCell.rsrqResult, 0, 34);
+            }
+
+          if (it.haveMeasResultBestNeighCell)
+            {
+              // Serialize physCellId-r10
+              SerializeInteger (it.measResultBestNeighCell.physCellId, 0, 503);
+
+              // Serialize rsrpResultNCell-r10
+              SerializeInteger (it.measResultBestNeighCell.rsrpResult, 0, 97);
+
+              // Serialize rsrqResultNCell-r10
+              SerializeInteger (it.measResultBestNeighCell.rsrqResult, 0, 34);
+            }
+
+          NS_ASSERT (!it.haveMeasResultBestNeighCell); // Not implemented
+        }
+    }
 }
 
 void
@@ -1729,22 +1737,32 @@
   {
     // 3 optional fields. Extension marker not present.
     std::bitset<3> noncriticalExtension_v1020;
-    noncriticalExtension_v1020.set (2,0); // No sCellToRealeaseList-r10
-    noncriticalExtension_v1020.set (1,1); // sCellToAddModList-r10
-    noncriticalExtension_v1020.set (0,0); // No nonCriticalExtension RRCConnectionReconfiguration-v1130-IEs
+    noncriticalExtension_v1020.set (2, !nonCriticalExtension.sCellToReleaseList.empty ()); // sCellToReleaseList-r10
+    noncriticalExtension_v1020.set (1, !nonCriticalExtension.sCellToAddModList.empty ()); // sCellToAddModList-r10
+    noncriticalExtension_v1020.set (0, 0); // No nonCriticalExtension RRCConnectionReconfiguration-v1130-IEs
     SerializeSequence (noncriticalExtension_v1020,false);
-    if (!nonCriticalExtension.sCellsToAddModList.empty ())
+
+    if (!nonCriticalExtension.sCellToReleaseList.empty ())
+      {
+        SerializeSequenceOf (nonCriticalExtension.sCellToReleaseList.size (), MAX_OBJECT_ID, 1);
+        for (uint8_t sCellIndex: nonCriticalExtension.sCellToReleaseList)
+          {
+            SerializeInteger (sCellIndex, 1, 7); // sCellIndex-r10
+          }
+      }
+
+    if (!nonCriticalExtension.sCellToAddModList.empty ())
       {
-        SerializeSequenceOf (nonCriticalExtension.sCellsToAddModList.size (),MAX_OBJECT_ID,1);
-        for (std::list<LteRrcSap::SCellToAddMod>::iterator it = nonCriticalExtension.sCellsToAddModList.begin (); it != nonCriticalExtension.sCellsToAddModList.end (); it++)
+        SerializeSequenceOf (nonCriticalExtension.sCellToAddModList.size (), MAX_OBJECT_ID, 1);
+        for (auto &it: nonCriticalExtension.sCellToAddModList)
           {
             std::bitset<4> sCellToAddMod_r10;
             sCellToAddMod_r10.set (3,1); // sCellIndex
             sCellToAddMod_r10.set (2,1); // CellIdentification
             sCellToAddMod_r10.set (1,1); // RadioResourceConfigCommonSCell
-            sCellToAddMod_r10.set (0,it->haveRadioResourceConfigDedicatedSCell); // No nonCriticalExtension RRC
+            sCellToAddMod_r10.set (0, it.haveRadioResourceConfigDedicatedSCell); // No nonCriticalExtension RRC
             SerializeSequence (sCellToAddMod_r10, false);
-            SerializeInteger (it->sCellIndex,1,MAX_OBJECT_ID); //sCellIndex
+            SerializeInteger (it.sCellIndex, 1, 7); // sCellIndex-r10
 
             // Serialize CellIdentification
             std::bitset<2> cellIdentification_r10;
@@ -1752,25 +1770,20 @@
             cellIdentification_r10.set(0,1); // dl-CarrierFreq-r10
             SerializeSequence (cellIdentification_r10, false);
 
-            SerializeInteger (it->cellIdentification.physCellId,1,65536);
-            SerializeInteger (it->cellIdentification.dlCarrierFreq,1,MAX_EARFCN);
+            SerializeInteger (it.cellIdentification.physCellId, 1, 65536);
+            SerializeInteger (it.cellIdentification.dlCarrierFreq, 1, MAX_EARFCN);
             
             //Serialize RadioResourceConfigCommonSCell
-            SerializeRadioResourceConfigCommonSCell (it->radioResourceConfigCommonSCell);
+            SerializeRadioResourceConfigCommonSCell (it.radioResourceConfigCommonSCell);
             
-            if (it->haveRadioResourceConfigDedicatedSCell)
+            if (it.haveRadioResourceConfigDedicatedSCell)
               {
                 //Serialize RadioResourceConfigDedicatedSCell
-                SerializeRadioResourceDedicatedSCell (it->radioResourceConfigDedicateSCell);
+                SerializeRadioResourceDedicatedSCell (it.radioResourceConfigDedicatedSCell);
               }
             
           }
       }
-    else
-      {
-        //        NS_ASSERT_MSG ( this << "NonCriticalExtension.sCellsToAddModList cannot be empty ", false);
-      }
-  
   }
   void
   RrcAsn1Header::SerializeRadioResourceConfigCommonSCell (LteRrcSap::RadioResourceConfigCommonSCell rrccsc) const
@@ -2600,44 +2613,69 @@
         bIterator = DeserializeSequence (&nonCriticalExtension_v920, false, bIterator);
         if (nonCriticalExtension_v920[0])
           {
-            // Continue to deserialize futere Release optional fields
+            // Continue to deserialize future Release optional fields
             std::bitset<3> nonCriticalExtension_v1020;
             bIterator = DeserializeSequence (&nonCriticalExtension_v1020, false, bIterator);
-            NS_ASSERT (!nonCriticalExtension_v1020[2]); // No sCellToRealeaseList-r10
-            NS_ASSERT (nonCriticalExtension_v1020[1]); // sCellToAddModList-r10
-            NS_ASSERT (!nonCriticalExtension_v1020[0]); // No nonCriticalExtension RRCConnectionReconfiguration-v1130-IEs
 
-            int numElems;
-            bIterator = DeserializeSequenceOf (&numElems,MAX_OBJECT_ID,1,bIterator);
-            nonCriticalExtension->sCellsToAddModList.clear ();
-            // Deserialize SCellToAddMod
-            for (int i = 0; i < numElems; i++)
+            if (nonCriticalExtension_v1020[2])
               {
-                std::bitset<4> sCellToAddMod_r10;
-                bIterator = DeserializeSequence (&sCellToAddMod_r10, false, bIterator); 
-                
-                LteRrcSap::SCellToAddMod sctam;
-                // Deserialize sCellIndex
-                NS_ASSERT (sCellToAddMod_r10[3]); // sCellIndex
-                int n;
-                bIterator = DeserializeInteger (&n,1,MAX_OBJECT_ID,bIterator);
-                sctam.sCellIndex = n;
-                // Deserialize CellIdentification
-                NS_ASSERT (sCellToAddMod_r10[2]); // CellIdentification
-                bIterator = DeserializeCellIdentification (&sctam.cellIdentification, bIterator);
-
-                // Deserialize RadioResourceConfigCommonSCell
-                NS_ASSERT (sCellToAddMod_r10[1]);
-                bIterator = DeserializeRadioResourceConfigCommonSCell (&sctam.radioResourceConfigCommonSCell, bIterator);
-                sctam.haveRadioResourceConfigDedicatedSCell = sCellToAddMod_r10[0];
-                if (sCellToAddMod_r10[0])
+                // sCellToReleaseList-r10
+                int numElems;
+
+                bIterator = DeserializeSequenceOf (&numElems, MAX_OBJECT_ID, 1, bIterator);
+                nonCriticalExtension->sCellToReleaseList.clear ();
+
+                for (int i = 0; i < numElems; i++)
                   {
-                    //Deserialize RadioResourceConfigDedicatedSCell
-                    bIterator = DeserializeRadioResourceConfigDedicatedSCell (&sctam.radioResourceConfigDedicateSCell, bIterator);
+                    // Deserialize SCellIndex-r10
+                    int sCellIndex;
+                    bIterator = DeserializeInteger (&sCellIndex, 1, 7, bIterator);
+                    nonCriticalExtension->sCellToReleaseList.push_back (sCellIndex);
                   }
+              }
+
+            if (nonCriticalExtension_v1020[1])
+              {
+                // sCellToAddModList-r10
+
+                int numElems;
+                bIterator = DeserializeSequenceOf (&numElems, MAX_OBJECT_ID, 1, bIterator);
+                nonCriticalExtension->sCellToAddModList.clear ();
+                // Deserialize SCellToAddMod
+                for (int i = 0; i < numElems; i++)
+                  {
+                    std::bitset<4> sCellToAddMod_r10;
+                    bIterator = DeserializeSequence (&sCellToAddMod_r10, false, bIterator);
 
-                nonCriticalExtension->sCellsToAddModList.insert (nonCriticalExtension->sCellsToAddModList.end (), sctam);
+                    LteRrcSap::SCellToAddMod sctam;
+                    // Deserialize sCellIndex
+                    NS_ASSERT (sCellToAddMod_r10[3]); // sCellIndex
+                    int n;
+                    bIterator = DeserializeInteger (&n, 1, 7, bIterator);
+                    sctam.sCellIndex = n;
+                    // Deserialize CellIdentification
+                    NS_ASSERT (sCellToAddMod_r10[2]); // CellIdentification
+                    bIterator = DeserializeCellIdentification (&sctam.cellIdentification, bIterator);
+
+                    // Deserialize RadioResourceConfigCommonSCell
+                    NS_ASSERT (sCellToAddMod_r10[1]);
+                    bIterator = DeserializeRadioResourceConfigCommonSCell (&sctam.radioResourceConfigCommonSCell, bIterator);
+                    if (sCellToAddMod_r10[0])
+                      {
+                        sctam.haveRadioResourceConfigDedicatedSCell = true;
+                        //Deserialize RadioResourceConfigDedicatedSCell
+                        bIterator = DeserializeRadioResourceConfigDedicatedSCell (&sctam.radioResourceConfigDedicatedSCell, bIterator);
+                      }
+                    else
+                      {
+                        sctam.haveRadioResourceConfigDedicatedSCell = false; 
+                      }
+
+                    nonCriticalExtension->sCellToAddModList.push_back (sctam);
+                  }
               }
+
+            NS_ASSERT (!nonCriticalExtension_v1020[0]); // No nonCriticalExtension RRCConnectionReconfiguration-v1130-IEs
           }
       }
 
@@ -3553,14 +3591,14 @@
 
   // Deserialize rsrpResult
   bIterator = DeserializeInteger (&n, 0, 97, bIterator);
-  measResults->rsrpResult = n;
+  measResults->measResultPCell.rsrpResult = n;
 
   // Deserialize rsrqResult
   bIterator = DeserializeInteger (&n, 0, 34, bIterator);
-  measResults->rsrqResult = n;
+  measResults->measResultPCell.rsrqResult = n;
 
   measResults->haveMeasResultNeighCells = measResultOptionalPresent[0];
-  measResults->haveScellsMeas = measResultOptionalPresent[3];
+  measResults->haveMeasResultServFreqList = measResultOptionalPresent[3];
   if ( measResults->haveMeasResultNeighCells)
     {
       int measResultNeighCellsChoice;
@@ -3663,51 +3701,53 @@
           // ...
         }
     }
-    if (measResults->haveScellsMeas)
+    if (measResults->haveMeasResultServFreqList)
       {
-
+      
         int numElems;
-        bIterator = DeserializeSequenceOf (&numElems,MAX_SCELL_REPORT,1,bIterator);
+        bIterator = DeserializeSequenceOf (&numElems, MAX_SCELL_REPORT, 1, bIterator);
         for (int i = 0; i < numElems; i++)
           {
-            LteRrcSap::MeasResultScell measResultScell;
-            int measScellId;
-            // Deserialize measId
-            bIterator = DeserializeInteger (&measScellId, 1,MAX_SCELL_REPORT,bIterator);
-            measResultScell.servFreqId = measScellId;
+            LteRrcSap::MeasResultServFreq measResultServFreq;
+
+            // Deserialize MeasResultServFreq-r10
             std::bitset<2> measResultScellPresent;
-            bIterator = DeserializeSequence (&measResultScellPresent,true,bIterator);
-            measResults->measScellResultList.haveMeasurementResultsServingSCells = measResultScellPresent[0];
-           measResults->measScellResultList.haveMeasurementResultsNeighCell = measResultScellPresent[1];
-           if (measResults->measScellResultList.haveMeasurementResultsServingSCells)
-             {
-               // Deserialize measResult
-               std::bitset<2> measResultOpts;
-               bIterator = DeserializeSequence (&measResultOpts, true, bIterator);
-
-               measResultScell.haveRsrpResult = measResultOpts[1];
-               if (measResultOpts[1])
-                 {
-                   // Deserialize rsrpResult
-                   bIterator = DeserializeInteger (&n,0,97,bIterator);
-                   measResultScell.rsrpResult = n;
-                 }
-
-               measResultScell.haveRsrqResult = measResultOpts[0];
-               if (measResultOpts[0])
-                 {
-                   // Deserialize rsrqResult
-                   bIterator = DeserializeInteger (&n,0,34,bIterator);
-                   measResultScell.rsrqResult = n;
-                 }
-             }
-           if (measResults->measScellResultList.haveMeasurementResultsNeighCell)
-             {
-               // Deserialize measResultBestNeighCell
-             }
-           measResults->measScellResultList.measResultScell.push_back (measResultScell);
+            bIterator = DeserializeSequence (&measResultScellPresent, true, bIterator);
+            measResultServFreq.haveMeasResultSCell = measResultScellPresent[0];
+            measResultServFreq.haveMeasResultBestNeighCell = measResultScellPresent[1];
+
+            // Deserialize servFreqId-r10
+            int servFreqId;
+            bIterator = DeserializeInteger (&servFreqId, 0, 7, bIterator);
+            measResultServFreq.servFreqId = servFreqId;
+
+            if (measResultServFreq.haveMeasResultSCell)
+              {
+                // Deserialize rsrpResult
+                bIterator = DeserializeInteger (&n, 0, 97, bIterator);
+                measResultServFreq.measResultSCell.rsrpResult = n;
+
+                // Deserialize rsrqResult
+                bIterator = DeserializeInteger (&n, 0, 34, bIterator);
+                measResultServFreq.measResultSCell.rsrqResult = n;
+              }
+
+            if (measResultServFreq.haveMeasResultBestNeighCell)
+              {
+                // Deserialize physCellId-r10
+                bIterator = DeserializeInteger (&n, 0, 503, bIterator);
+                measResultServFreq.measResultBestNeighCell.physCellId = n;
+
+                // Deserialize rsrpResultNCell-r10
+                bIterator = DeserializeInteger (&n, 0, 97, bIterator);
+                measResultServFreq.measResultBestNeighCell.rsrpResult = n;
+
+                // Deserialize rsrqResultNCell-r10
+                bIterator = DeserializeInteger (&n, 0, 34, bIterator);
+                measResultServFreq.measResultBestNeighCell.rsrqResult = n;
+              }
+            measResults->measResultServFreqList.push_back (measResultServFreq);
           }
-        
       }
   return bIterator;
 }
@@ -5197,7 +5237,7 @@
         // Serialize NonCriticalExtension RRCConnectionReconfiguration-v920-IEs sequence:
         // 3 optional fields. Extension marker not present.
         std::bitset<3> noncriticalExtension_v920;
-        noncriticalExtension_v920.set (1,0); // No otehrConfig-r9
+        noncriticalExtension_v920.set (1,0); // No otherConfig-r9
         noncriticalExtension_v920.set (1,0); // No fullConfig-r9
         //Enable RRCCoonectionReconfiguration-v1020-IEs
         noncriticalExtension_v920.set (0,m_haveNonCriticalExtension); // Implemented nonCriticalExtension because compatibility with R10 - CA
@@ -6754,8 +6794,8 @@
 MeasurementReportHeader::Print (std::ostream &os) const
 {
   os << "measId = " << (int)m_measurementReport.measResults.measId << std::endl;
-  os << "rsrpResult = " << (int)m_measurementReport.measResults.rsrpResult << std::endl;
-  os << "rsrqResult = " << (int)m_measurementReport.measResults.rsrqResult << std::endl;
+  os << "rsrpResult = " << (int)m_measurementReport.measResults.measResultPCell.rsrpResult << std::endl;
+  os << "rsrqResult = " << (int)m_measurementReport.measResults.measResultPCell.rsrqResult << std::endl;
   os << "haveMeasResultNeighCells = " << (int)m_measurementReport.measResults.haveMeasResultNeighCells << std::endl;
 
   if (m_measurementReport.measResults.haveMeasResultNeighCells)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/lte/model/lte-rrc-header.h ns-3.36/src/lte/model/lte-rrc-header.h
--- ns-3.35/src/lte/model/lte-rrc-header.h	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/lte/model/lte-rrc-header.h	2022-04-30 18:23:58.046734300 -0700
@@ -827,8 +827,8 @@
   LteRrcSap::MobilityControlInfo m_mobilityControlInfo; ///< the modility control info
   bool m_haveRadioResourceConfigDedicated; ///< have radio resource config dedicated?
   LteRrcSap::RadioResourceConfigDedicated m_radioResourceConfigDedicated; ///< the radio resource config dedicated
-  bool m_haveNonCriticalExtension; ///< Have critical extension
-  LteRrcSap::NonCriticalExtensionConfiguration m_nonCriticalExtension; ///< the critical extension
+  bool m_haveNonCriticalExtension; ///< Have non-critical extension
+  LteRrcSap::NonCriticalExtensionConfiguration m_nonCriticalExtension; ///< the non-critical extension
 };
 
 /**
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/lte/model/lte-rrc-protocol-ideal.cc ns-3.36/src/lte/model/lte-rrc-protocol-ideal.cc
--- ns-3.35/src/lte/model/lte-rrc-protocol-ideal.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/lte/model/lte-rrc-protocol-ideal.cc	2022-04-30 18:23:58.046734300 -0700
@@ -373,7 +373,7 @@
               if (ueRrc->GetCellId () == cellId)
                 {       
                   NS_LOG_LOGIC ("sending SI to IMSI " << ueDev->GetImsi ());
-                  ueRrc->GetLteUeRrcSapProvider ()->RecvSystemInformation (msg);
+                  
                   Simulator::Schedule (RRC_IDEAL_MSG_DELAY, 
                                        &LteUeRrcSapProvider::RecvSystemInformation,
                                        ueRrc->GetLteUeRrcSapProvider (), 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/lte/model/lte-rrc-sap.h ns-3.36/src/lte/model/lte-rrc-sap.h
--- ns-3.35/src/lte/model/lte-rrc-sap.h	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/lte/model/lte-rrc-sap.h	2022-04-30 18:23:58.046734300 -0700
@@ -632,6 +632,13 @@
     std::list<uint32_t> plmnIdentityList; ///< PLMN identity list
   };
 
+  /// MeasResultPCell structure
+  struct MeasResultPCell
+  {
+    uint8_t rsrpResult; ///< the RSRP result
+    uint8_t rsrqResult; ///< the RSRQ result
+  };
+
   /// MeasResultEutra structure
   struct MeasResultEutra
   {
@@ -644,46 +651,39 @@
     uint8_t rsrqResult; ///< RSRQ result
   };
 
-  /// MeasResultScell structure
-  struct MeasResultScell
+  /// MeasResultSCell structure
+  struct MeasResultSCell
   {
-    uint16_t servFreqId; ///< service frequency ID
-    bool haveRsrpResult; ///< have RSRP result?
     uint8_t rsrpResult; ///< the RSRP result
-    bool haveRsrqResult; ///< have RSRQ result?
     uint8_t rsrqResult; ///< the RSRQ result
   };
 
   /// MeasResultBestNeighCell structure
   struct MeasResultBestNeighCell
   {
-    uint16_t servFreqId; ///< service frequency ID
     uint16_t physCellId; ///< physical cell ID
-    bool haveRsrpResult; ///< have RSRP result?
     uint8_t rsrpResult; ///< the RSRP result
-    bool haveRsrqResult; ///< have RSRQ result?
     uint8_t rsrqResult; ///< the RSRQ result
   };
 
-  /// MeasResultServFreqList
-  struct MeasResultServFreqList
-  {
-    bool haveMeasurementResultsServingSCells; ///< have measure results serving Scells
-    std::list<MeasResultScell> measResultScell; ///< measure results Scells
-    bool haveMeasurementResultsNeighCell; ///< always false since not implemented
-    std::list<MeasResultBestNeighCell> measResultBestNeighCell; ///< measure result best neighbor cell
+  /// MeasResultServFreq structure
+  struct MeasResultServFreq {
+    uint16_t servFreqId; ///< serving cell index
+    bool haveMeasResultSCell; ///< have measResultSCell?
+    MeasResultSCell measResultSCell; ///< SCell measurement results
+    bool haveMeasResultBestNeighCell; ///< have measResultBestNeighCell?
+    MeasResultBestNeighCell measResultBestNeighCell; ///< best neighbor cell measurement results
   };
 
   /// MeasResults structure
   struct MeasResults
   {
     uint8_t measId; ///< measure ID
-    uint8_t rsrpResult; ///< RSRP result
-    uint8_t rsrqResult; ///< RSRQ result
+    MeasResultPCell measResultPCell; ///< measurement result primary cell
     bool haveMeasResultNeighCells; ///< have measure result neighbor cells
     std::list<MeasResultEutra> measResultListEutra; ///< measure result list eutra
-    bool haveScellsMeas; ///< has SCells measure
-    MeasResultServFreqList measScellResultList; ///< measure SCell result list
+    bool haveMeasResultServFreqList; ///< has measResultServFreqList-r10
+    std::list<MeasResultServFreq> measResultServFreqList; ///< MeasResultServFreqList-r10
   };
 
   // Messages
@@ -822,14 +822,14 @@
     CellIdentification cellIdentification; ///< cell identification
     RadioResourceConfigCommonSCell radioResourceConfigCommonSCell; ///< radio resource config common SCell
     bool haveRadioResourceConfigDedicatedSCell; ///< have radio resource config dedicated SCell?
-    RadioResourceConfigDedicatedSCell radioResourceConfigDedicateSCell; ///< radio resource config dedicated SCell
+    RadioResourceConfigDedicatedSCell radioResourceConfigDedicatedSCell; ///< radio resource config dedicated SCell
   };
 
   /// NonCriticalExtensionConfiguration structure
   struct NonCriticalExtensionConfiguration
   {
-    std::list<SCellToAddMod> sCellsToAddModList; ///< SCell to add mod list
-    std::list<uint32_t> sCellToReleaseList; ///< SCell to release list
+    std::list<SCellToAddMod> sCellToAddModList; ///< SCell to add mod list
+    std::list<uint8_t> sCellToReleaseList; ///< SCell to release list
   };
 
   /// RrcConnectionReconfiguration structure
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/lte/model/lte-spectrum-phy.cc ns-3.36/src/lte/model/lte-spectrum-phy.cc
--- ns-3.35/src/lte/model/lte-spectrum-phy.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/lte/model/lte-spectrum-phy.cc	2022-04-30 18:23:58.046734300 -0700
@@ -348,6 +348,13 @@
   m_rxPacketBurstList.clear ();
   m_txPacketBurst = 0;
   m_rxSpectrumModel = 0;
+
+  // Detach from the channel, because receiving any signal without
+  // spectrum model is an error.
+  if (m_channel)
+    {
+      m_channel->RemoveRx (this);
+    }
 }
 
 
@@ -403,8 +410,8 @@
 }
 
 
-Ptr<AntennaModel>
-LteSpectrumPhy::GetRxAntenna () const
+Ptr<Object>
+LteSpectrumPhy::GetAntenna () const
 {
   return m_antenna;
 }
@@ -1011,7 +1018,7 @@
             }
           TbStats_t tbStats = LteMiErrorModel::GetTbDecodificationStats (m_sinrPerceived, (*itTb).second.rbBitmap, (*itTb).second.size, (*itTb).second.mcs, harqInfoList);
           (*itTb).second.mi = tbStats.mi;
-          (*itTb).second.corrupt = m_random->GetValue () > tbStats.tbler ? false : true;
+          (*itTb).second.corrupt = !(m_random->GetValue () > tbStats.tbler);
           NS_LOG_DEBUG (this << "RNTI " << (*itTb).first.m_rnti << " size " << (*itTb).second.size << " mcs " << (uint32_t)(*itTb).second.mcs << " bitmap " << (*itTb).second.rbBitmap.size () << " layer " << (uint16_t)(*itTb).first.m_layer << " TBLER " << tbStats.tbler << " corrupted " << (*itTb).second.corrupt);
           // fire traces on DL/UL reception PHY stats
           PhyReceptionStatParameters params;
@@ -1193,7 +1200,7 @@
   if (m_ctrlErrorModelEnabled)
     {
       double  errorRate = LteMiErrorModel::GetPcfichPdcchError (m_sinrPerceived);
-      error = m_random->GetValue () > errorRate ? false : true;
+      error = !(m_random->GetValue () > errorRate);
       NS_LOG_DEBUG (this << " PCFICH-PDCCH Decodification, errorRate " << errorRate << " error " << error);
     }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/lte/model/lte-spectrum-phy.h ns-3.36/src/lte/model/lte-spectrum-phy.h
--- ns-3.35/src/lte/model/lte-spectrum-phy.h	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/lte/model/lte-spectrum-phy.h	2022-04-30 18:23:58.046734300 -0700
@@ -180,7 +180,7 @@
   Ptr<MobilityModel> GetMobility () const;
   Ptr<NetDevice> GetDevice () const;
   Ptr<const SpectrumModel> GetRxSpectrumModel () const;
-  Ptr<AntennaModel> GetRxAntenna () const;
+  Ptr<Object> GetAntenna () const;
   void StartRx (Ptr<SpectrumSignalParameters> params);
   /**
    * \brief Start receive data function
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/lte/model/lte-spectrum-value-helper.cc ns-3.36/src/lte/model/lte-spectrum-value-helper.cc
--- ns-3.35/src/lte/model/lte-spectrum-value-helper.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/lte/model/lte-spectrum-value-helper.cc	2022-04-30 18:23:58.046734300 -0700
@@ -30,6 +30,16 @@
 // just needed to log a std::vector<int> properly...
 namespace std {
 
+/**
+ * \brief Stream insertion operator.
+ * 
+ * \note This function scope is stricly local, and can not be 
+ * used in other source files.
+ *
+ * \param [in] os The reference to the output stream.
+ * \param [in] v The std::vector<int>.
+ * \returns The reference to the output stream.
+ */
 ostream&
 operator << (ostream& os, const vector<int>& v)
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/lte/model/lte-ue-component-carrier-manager.h ns-3.36/src/lte/model/lte-ue-component-carrier-manager.h
--- ns-3.35/src/lte/model/lte-ue-component-carrier-manager.h	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/lte/model/lte-ue-component-carrier-manager.h	2022-04-30 18:23:58.046734300 -0700
@@ -106,7 +106,7 @@
 
   std::map<uint8_t, LteMacSapUser*> m_lcAttached; //!< Map of pointers to SAP interfaces of the RLC instance of the flows of this UE.
   std::map<uint8_t, std::map<uint8_t, LteMacSapProvider*> > m_componentCarrierLcMap; //!< Flow configuration per flow Id of this UE.
-  uint16_t m_noOfComponentCarriers; //!<// The number of component carriers that this UE can support.
+  uint8_t m_noOfComponentCarriers; //!< The number of component carriers that this UE can support.
   std::map <uint8_t, LteMacSapProvider*> m_macSapProvidersMap; //!< Map of pointers to SAP to interfaces of the MAC instance if the flows of this UE.
 
 }; // end of class LteUeComponentCarrierManager
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/lte/model/lte-ue-cphy-sap.h ns-3.36/src/lte/model/lte-ue-cphy-sap.h
--- ns-3.35/src/lte/model/lte-ue-cphy-sap.h	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/lte/model/lte-ue-cphy-sap.h	2022-04-30 18:23:58.046734300 -0700
@@ -104,6 +104,18 @@
   virtual void SynchronizeWithEnb (uint16_t cellId, uint32_t dlEarfcn) = 0;
 
   /**
+   * \brief Get PHY cell ID
+   * \return cell ID this PHY is synchronized to
+   */
+  virtual uint16_t GetCellId () = 0;
+
+  /**
+   * \brief Get PHY DL EARFCN
+   * \return DL EARFCN this PHY is synchronized to
+   */
+  virtual uint32_t GetDlEarfcn () = 0;
+
+  /**
    * \param dlBandwidth the DL bandwidth in number of PRBs
    */
   virtual void SetDlBandwidth (uint16_t dlBandwidth) = 0;
@@ -316,6 +328,8 @@
   virtual void StartCellSearch (uint32_t dlEarfcn);
   virtual void SynchronizeWithEnb (uint16_t cellId);
   virtual void SynchronizeWithEnb (uint16_t cellId, uint32_t dlEarfcn);
+  virtual uint16_t GetCellId ();
+  virtual uint32_t GetDlEarfcn ();
   virtual void SetDlBandwidth (uint16_t dlBandwidth);
   virtual void ConfigureUplink (uint32_t ulEarfcn, uint16_t ulBandwidth);
   virtual void ConfigureReferenceSignalPower (int8_t referenceSignalPower);
@@ -374,6 +388,20 @@
 }
 
 template <class C>
+uint16_t
+MemberLteUeCphySapProvider<C>::GetCellId ()
+{
+  return m_owner->DoGetCellId ();
+}
+
+template <class C>
+uint32_t
+MemberLteUeCphySapProvider<C>::GetDlEarfcn ()
+{
+  return m_owner->DoGetDlEarfcn ();
+}
+
+template <class C>
 void
 MemberLteUeCphySapProvider<C>::SetDlBandwidth (uint16_t dlBandwidth)
 {
